#!/usr/bin/perl
#########################################################################
#    Site-Index-builder.pl create index pages of html files from a given 
#    directory path. It trees down to all levels.
#    Copyright (C) 2011  Dennis Cohen - kiss programming
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#########################################################################



use strict;
use base "HTML::Parser";
use HTML::HeadParser;
use Data::Dumper;

my      $files = {};
my      $sitepath = 'PATH TO SITES HOME DIRECTORY';# path to Sites home directory
my      $startpath = $sitepath ."ADDED PATH TO START";# path start of content area

        @{$files->{topdirs}} = <$startpath/*>;
        read_dirs($startpath,$files);
        read_files($sitepath,$files);
        create_page($sitepath,$files);
exit;


sub read_dirs#  creates multy level list in order of search of directories
{
my      $startpath = shift;
my      $files = shift;
my      $dir;
        foreach $dir (<$startpath/*>)
        {
                if(-d $dir)
                {
                        if($dir =~ qw[images|common|indexes|link-pages]){next;}# list of ignored directories
                        push(@{$files->{fdirs}}, $dir);
                        read_dirs($dir,$files)
                }
        }
}

sub read_files#                 get all HTML files under searched  directores
{
my      $sitepath = shift;
my      $files = shift;

my      $dir;
my      $file;
my      @dirs;
my      @Order;
my      @UnOrder;
my      $title;
        foreach $dir (@{$files->{fdirs}})
        {
#	the <$dir/*.html> looks for all HTML files  to look for others change the Dot HTML ext	
                foreach $file (<$dir/*.html>)
                {
                        $title = read_title($title,$file);
                        $file =~ s/$sitepath//g;
                        $files->{files}->{$file} = $title;
                }
        }
}

sub read_title#         reads the between <title></title> tags
{
my      $title = shift;
my      $file = shift;
my      $h = HTML::HeadParser->new;
        open(FP,"$file");
        while (<FP>) {
                $h->parse($_) ;
        }
        $title = $h->header('title');
# filters to clean up title
        $title =~ s/[^a-zA-Z0-9 -: ]//g;
        $title =~ s/^\s+//;
        $title =~ s/^[ -]//;
        $title =~ s/\s+&//;
        $title =~ s/(\w+)/\u$1/g;
        $title =~s/^\s+//;
return($title);
}

sub create_page
{
my $sitepath = shift;
my $files = shift;

my $dir;
my $tmpdir;
my @dirlevels;
my @ldirlevels;
my $dirlevelcnt;

my $file;
my $tmpfile;
my @filelist;
my @filelevels;
my $lncnt;
my $myclose = 0;

# print Data::Dumper->Dump([$files]);
        foreach $dir (@{$files->{fdirs}})
        {
                $dir =~ s/$sitepath//g;# Get the relivite path of directories
                $tmpdir = $dir;
                $tmpdir =~ s/^\///g; # remove leading slash
                @dirlevels = split(/\//,$tmpdir);# array of directories
                $dirlevelcnt = scalar(@dirlevels);# count of directories
                if($dirlevels[0] ne $ldirlevels[0])# check for toplevel directory change
                {
                        if( $myclose == 1)# check if file open
                        {
                        print FP "<td>&nbsp;</td>\n" if($lncnt % 2);
                        print FP "</tr></table>\n";
                        close(FP);
                        }
                        open( FP, "> $sitepath/indexes/$dirlevels[0]index.html") || die "cant open file";
                        $myclose = 1;
                        $lncnt = 0;
#                               **--> create start of table amd mail page title <--**




                        print FP "<table><tr>\n";
                        print FP "<td colspan='2' align='center'class='gld-txt-16'>$dirlevels[0]</td>\n";
                        print FP "</tr><tr>\n";




                }

#                       **--> cycle thru list of files and match to directory <--**
                $files->{pageorder} = [];
                foreach $file (keys %{$files->{files}})
                {
                        @filelist = split(/\//,$file);# get the HTML file
                        $tmpfile = $dir ."/".$filelist[scalar(@filelist) - 1];#create file compair string # attach HTML file to a temp copy of the current directory
                        if($file =~ m/$tmpfile/)# match to see if file path is equal to directory path
                        {

#                       **--> create first level subcatagory title cell <--**

                                if($dirlevelcnt => 2 && $dirlevels[1] ne $ldirlevels[1])
                                {
                                        if( $lncnt % 2)
                                        {
                                                print FP "</tr><tr>\n";
                                                $lncnt++;
                                        }

                                        print FP "<td colspan='2' align='center'class='gld-txt-14'>$dirlevels[1]</td></tr><tr>\n";
                                        $ldirlevels[1] = $dirlevels[1];
                                }
#                       **--> create second level subcatagory title cell <--**

                                if($dirlevelcnt => 3 && $dirlevels[2] ne $ldirlevels[2])
                                {
                                        if( $lncnt % 2)
                                        {
                                                print FP "</tr><tr>\n";
                                                $lncnt++;
                                        }

                                        print FP "<td colspan='2' align='center'class='gld-txt-14'>$dirlevels[2]</td></tr><tr>\n";
                                        $ldirlevels[2] = $dirlevels[2];
                                }
#                       **--> create page list content <--**
my                              $title = $files->{files}->{$file};
                                unless($title){next;}
                                print FP "<td><a href='$file'>$title</a></td>\n";
                                if( $lncnt % 2)
                                {
                                        print FP "</tr><tr>\n";
                                }
                                $lncnt++;

                        }
                }

                $ldirlevels[0] = $dirlevels[0];
        }
        print FP "<td>&nbsp;</td>\n" if($lncnt % 2);
        print FP "</tr></table>\n";
        close(FP);
}

